;##################################################################
; LVDesktop9xNT
;##################################################################

#Define WM_CLOSE 010h
#Define WM_INITDIALOG 0110h
#Define WM_COMMAND 0111h

#Define LVM_GETITEMCOUNT 01004h
#Define LVM_GETITEM 01005h
#Define LVM_SETITEM 01006h
#Define LVM_INSERTITEM 01007h
#Define LVM_GETITEMPOSITION 01010h
#Define LVM_INSERTCOLUMN 0101Bh
#Define LVM_SETEXTENDEDLISTVIEWSTYLE 01036h
#Define LVM_SETIMAGELIST 01003h

#Define LVIF_TEXT 01h
#Define LVIF_IMAGE 02h
#Define LVIF_PARAM 04h

#Define LVCF_FMT 01h
#Define LVCF_WIDTH 02h
#Define LVCF_TEXT 04h
#Define LVCF_SUBITEM 08h

#Define LVCFMT_LEFT 0h
#Define LVCFMT_CENTER 0002h

#Define LVSIL_NORMAL 0
#Define LVSIL_SMALL 1

#Define LVS_EX_GRIDLINES 01h
#Define LVS_EX_FULLROWSELECT 020h

#Define PROCESS_VM_OPERATION 08h
#Define PROCESS_VM_READ 010h
#Define PROCESS_VM_WRITE 020h

#Define MEM_COMMIT 01000h
#Define MEM_RELEASE 08000h

#Define PAGE_READWRITE 04h

#Define SHGFI_PIDL 08h
#Define SHGFI_TYPENAME 0400h
#Define SHGFI_SYSICONINDEX 4000h

#Define MAX_PATH 0104h
#Define IDD_DLG1 03E8h

#Define WM_GETMINMAXINFO 24h
#Define WM_ERASEBKGND 14h
#Define WM_ENTERSIZEMOVE 231h
#Define WM_EXITSIZEMOVE 232h
#Define WM_WINDOWPOSCHANGED 47h

RECT STRUCT
  left    dd
  top     dd
  right   dd
  bottom  dd
ENDS

WINDOWPOS STRUCT
  hwnd              DD
  hWndInsertAfter   DD
  x                 DD
  y                 DD
  lx                DD
  cy                DD
  flags             DD
ENDS

MINMAXINFO STRUCT
  ptReserved        POINT         <0>
  ptMaxSize         POINT         <0>
  ptMaxPosition     POINT         <0>
  ptMinTrackSize    POINT         <0>
  ptMaxTrackSize    POINT         <0>
ENDS

LV_ITEM STRUCT
  imask         DD
  iItem         DD
  iSubItem      DD
  state         DD
  stateMask     DD
  pszText       DD
  cchTextMax    DD
  iImage        DD
  lParam        DD
  iIndent       DD
ENDS

POINT STRUCT
  x  DD
  y  DD
ENDS

LV_COLUMN STRUCT
  imask         DD
  fmt           DD
  lx            DD
  pszText       DD
  cchTextMax    DD
  iSubItem      DD
  iImage        DD
  iOrder        DD
ENDS

SHFILEINFO STRUCT
  hIcon             DD
  iIcon             DD
  dwAttributes      DD
  szDisplayName     DB MAX_PATH DUP (?)
  szTypeName        DB 80 dup (?)
ENDS

; Interprocess memory allocation for 9x
; GoAsm allows you to equate these as follows
; in MASM you will have to work something else out:
Alloc = [pAlloc] ;COMCTL32.DLL:71
ReAlloc = [pReAlloc] ;COMCTL32.DLL:72
Free = [pFree] ;COMCTL32.DLL:73
GetSize = [pGetSize] ; COMCTL32.DLL:74

; Interprocess memory allocation for NT
VirtualAllocEx = [pVirtualAllocEx]
VirtualFreeEx = [pVirtualFreeEx]

/*
invoke Alloc, cb ; Ordinal COMCTL32.DLL:71
Returns pv (pointer to virtual memory)

invoke ReAlloc, pv, cb ; Ordinal COMCTL32.DLL:72
Returns pv (pointer to virtual memory)

invoke Free, pv ; Ordinal COMCTL32.DLL:73
Returns Non-zero

invoke GetSize, pv ; Ordinal COMCTL32.DLL:74
Returns bytes allocated
*/

MINHEIGHT equ 200
MINWIDTH equ 200

.DATA
; Initialized
	ALIGN 4
	szColumn0		DB			"Display name",0
	szColumn1		DB			"File type",0
	szColumn2		DB			"Path",0
	szColumn3		DB			"xpos",0
	szColumn4		DB			"ypos",0

; Uninitialized
	hInstance		DD 			?
	hShell32		DD			?
	hDesktopLV		DD			?
	pt				POINT		<?>
	lvi				LV_ITEM		<?>
	lvtext			DB			256 DUP (?)

	hListView		DD 			?

	pVirtualAllocEx	DD			?
	pVirtualFreeEx	DD			?

	pAlloc			DD			?
	pReAlloc		DD			?
	pFree			DD			?
	pGetSize		DD			?

	hSysImlSmall	DD			?
	hSysImlLarge	DD			?

	IsMoving		DD			?

.CODE

FindDesktopListview:
	invoke FindWindowA, "progman", 0
	invoke FindWindowExA, eax, 0, "SHELLDLL_DefView", 0
	invoke FindWindowExA, eax, 0, "SysListView32", 0
	mov [hDesktopLV], eax
	RET

Start:
	invoke InitCommonControls
	invoke GetModuleHandleA,0
	mov [hInstance],eax

	; The module handle of Shell32 is needed for a few calls
	invoke GetModuleHandleA,"Shell32.DLL"
	mov [hShell32],eax

	fs mov eax,[18h] ; Test for NT
	cmp eax,7FFDE000h
	jne >
		; NT requires that the system image list be initialized
		; for this process. This can only be run under NT, it is
		; only available as an ordinal export.
		invoke GetProcAddress,[hShell32],660
		or eax,eax
		jz >L1
			invoke eax,1
		L1:
		invoke LoadNTMemoryFunctions
		js >.ERROR
		jmp >.LOADOK
	:
		invoke Load9xMemoryFunctions
		js >.ERROR
	.LOADOK

	; Check to see if the Shell_GetImageLists function is available
	; This is only available in XP SP1 and above.
	invoke GetProcAddress,[hShell32],"Shell_GetImageLists"
	or eax,eax
	jnz >
		; If not available then load by ordinal
		invoke GetProcAddress,[hShell32],71
		or eax,eax
		jz >.ERROR
	:
	; The Shell_GetImageLists function was found so get the handles
	invoke eax,offset hSysImlLarge,offset hSysImlSmall

	invoke DialogBoxParamA,[hInstance],IDD_DLG1,0,ADDR DlgProc,0
	.ERROR
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses esi,edi
	LOCAL buffer[MAX_PATH]	:B
	LOCAL ptx[16]			:B
	LOCAL pty[16]			:B
	LOCAL sztype[64]		:B
	LOCAL rct				:RECT

	mov eax,[uMsg]
	.WMINITDIALOG
	cmp eax,WM_INITDIALOG
	jne >>.WMCOMMAND
		invoke GetDlgItem,[hwnd],03E9h
		mov [hListView],eax
		invoke SendMessageA,[hListView],LVM_SETIMAGELIST,LVSIL_SMALL,[hSysImlSmall]
		invoke SendMessageA,[hListView],LVM_SETIMAGELIST,LVSIL_NORMAL,[hSysImlLarge]
		invoke SetUpListView,[hListView]
		call FindDesktopListview
		invoke SendMessageA,[hDesktopLV],LVM_GETITEMCOUNT,0,0
		mov edi,eax

		mov D[lvi.imask],LVIF_TEXT + LVIF_PARAM + LVIF_IMAGE
		mov D[lvi.pszText],OFFSET lvtext
		mov D[lvi.cchTextMax],255

		mov esi,0
		jmp >>L2
			L1:
			mov D[lvi.iItem],esi
			mov D[lvi.iSubItem],0
			invoke GetRemoteItem,[hDesktopLV],OFFSET lvi
			invoke GetItemPos,[hDesktopLV],[lvi.iItem],offset pt
			invoke FindFullName,[hDesktopLV],[lvi.lParam],addr buffer,offset sztype
			push eax
			invoke wsprintfA,addr ptx,"%u",[pt.x]
			add esp,12
			invoke wsprintfA,addr pty,"%u",[pt.y]
			add esp,12
			pop eax
			invoke LVAddItem,[hListView],OFFSET lvtext,offset sztype,addr buffer,addr ptx,addr pty,eax
			inc esi
			L2:
		cmp esi,edi
		jl <<L1
		jmp >>.EXIT

	.WMCOMMAND
	cmp eax,WM_COMMAND
	jne >>.WMGETMINMAXINFO

		jmp >>.EXIT

	.WMGETMINMAXINFO
	cmp D[uMsg],WM_GETMINMAXINFO
	jne >.WMERASEBKGND
		mov edi,[lParam]
		mov D[edi+MINMAXINFO.ptMinTrackSize.x],MINWIDTH
		mov D[edi+MINMAXINFO.ptMinTrackSize.y],MINHEIGHT
		xor eax,eax
		ret

	.WMERASEBKGND
	cmp D[uMsg],WM_ERASEBKGND
	jne >.WMENTERSIZEMOVE
		cmp D[IsMoving],1
		jne >>.DEFPROC
		xor eax,eax
		inc eax
		ret

	.WMENTERSIZEMOVE
	cmp D[uMsg],WM_ENTERSIZEMOVE
	jne >.WMEXITSIZEMOVE
		mov D[IsMoving],1
		xor eax,eax
		ret

	.WMEXITSIZEMOVE
	cmp D[uMsg],WM_EXITSIZEMOVE
	jne >.WMWINDOWPOSCHANGED
		mov D[IsMoving],0
		invoke InvalidateRect,[hwnd],0,1
		invoke UpdateWindow,[hwnd]
		xor eax,eax
		ret

	.WMWINDOWPOSCHANGED
	cmp D[uMsg],WM_WINDOWPOSCHANGED
	jne >.WMCLOSE
		invoke GetClientRect,[hwnd],offset rct
		invoke MoveWindow,[hListView],0,0,[rct.right],[rct.bottom],1
		jmp >>.DEFPROC

	.WMCLOSE
	cmp eax,WM_CLOSE
	jne >>.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		sub eax,eax
		ret

	.EXIT

	sub eax,eax
	inc eax
	ret
ENDF

LVAddItem FRAME hlv,Col0,Col1,Col2,Col3,Col4,iImage
	LOCAL LVItem		:LV_ITEM
	LOCAL szItemID[16]	:B
	LOCAL ItemID		:D

	invoke SendMessageA,[hlv],LVM_GETITEMCOUNT,0,0
	mov [ItemID],eax

	mov D[LVItem.imask],LVIF_PARAM + LVIF_TEXT + LVIF_IMAGE
	mov D[LVItem.iSubItem],0
	mov eax,[Col0]
	mov [LVItem.pszText],eax
	mov eax,[iImage]
	mov [LVItem.iImage],eax

	mov D[LVItem.lParam],eax
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	invoke SendMessageA,[hlv],LVM_INSERTITEM,0,ADDR LVItem
	mov [ItemID],eax

	mov eax,[Col1]
	mov [LVItem.pszText],eax
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	mov D[LVItem.iSubItem],1
	mov D[LVItem.imask],LVIF_TEXT
	invoke SendMessageA,[hlv],LVM_SETITEM,0,ADDR LVItem

	mov eax,[Col2]
	mov [LVItem.pszText],eax
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	mov D[LVItem.iSubItem],2
	mov D[LVItem.imask],LVIF_TEXT
	invoke SendMessageA,[hlv],LVM_SETITEM,0,ADDR LVItem

	mov eax,[Col3]
	mov [LVItem.pszText],eax
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	mov D[LVItem.iSubItem],3
	mov D[LVItem.imask],LVIF_TEXT
	invoke SendMessageA,[hlv],LVM_SETITEM,0,ADDR LVItem
	
	mov eax,[Col4]
	mov [LVItem.pszText],eax
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	mov D[LVItem.iSubItem],4
	mov D[LVItem.imask],LVIF_TEXT
	invoke SendMessageA,[hlv],LVM_SETITEM,0,ADDR LVItem

	mov eax,[ItemID]
	ret
ENDF

SetUpListView FRAME hlv
	uses edi,esi
	LOCAL LVColumn		:LV_COLUMN

	mov D[LVColumn.imask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.lx],100
	mov D[LVColumn.pszText],OFFSET szColumn0
	mov D[LVColumn.cchTextMax],SIZEOF szColumn0
	invoke SendMessageA,[hlv],LVM_INSERTCOLUMN,0,ADDR LVColumn

	mov D[LVColumn.imask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.lx],100
	mov D[LVColumn.pszText],OFFSET szColumn1
	mov D[LVColumn.cchTextMax],SIZEOF szColumn1
	invoke SendMessageA,[hlv],LVM_INSERTCOLUMN,1,ADDR LVColumn

	mov D[LVColumn.imask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH + LVCF_SUBITEM
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.lx],235
	mov D[LVColumn.pszText],OFFSET szColumn2
	mov D[LVColumn.cchTextMax],SIZEOF szColumn2
	mov D[LVColumn.iSubItem],1
	invoke SendMessageA,[hlv],LVM_INSERTCOLUMN,2,ADDR LVColumn

	mov D[LVColumn.imask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH + LVCF_SUBITEM
	mov D[LVColumn.fmt],LVCFMT_CENTER
	mov D[LVColumn.lx],50
	mov D[LVColumn.pszText],OFFSET szColumn3
	mov D[LVColumn.cchTextMax],SIZEOF szColumn3
	mov D[LVColumn.iSubItem],2
	invoke SendMessageA,[hlv],LVM_INSERTCOLUMN,3,ADDR LVColumn
	
	mov D[LVColumn.imask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH + LVCF_SUBITEM
	mov D[LVColumn.fmt],LVCFMT_CENTER
	mov D[LVColumn.lx],50
	mov D[LVColumn.pszText],OFFSET szColumn4
	mov D[LVColumn.cchTextMax],SIZEOF szColumn4
	mov D[LVColumn.iSubItem],3
	invoke SendMessageA,[hlv],LVM_INSERTCOLUMN,4,ADDR LVColumn

	invoke SendMessageA,[hlv],LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT + LVS_EX_GRIDLINES,LVS_EX_GRIDLINES + LVS_EX_FULLROWSELECT 

	ret
ENDF

Load9xMemoryFunctions FRAME
	LOCAL hLib		:D

	invoke GetModuleHandleA,"COMCTL32.DLL"
	mov [hLib],eax

	invoke GetProcAddress,[hLib],71
	mov [pAlloc],eax
	or eax,eax
	jnz >
		xor eax,eax
		dec eax
		ret
	:

	invoke GetProcAddress,[hLib],72
	mov [pReAlloc],eax

	invoke GetProcAddress,[hLib],73
	mov [pFree],eax

	invoke GetProcAddress,[hLib],74
	mov [pGetSize],eax

	xor eax,eax
	RET
ENDF

LoadNTMemoryFunctions FRAME
	LOCAL hLib		:D

	invoke GetModuleHandleA,"Kernel32.dll"
	mov [hLib],eax

	invoke GetProcAddress,[hLib],"VirtualAllocEx"
	mov [pVirtualAllocEx],eax
	or eax,eax
	jnz >
		xor eax,eax
		dec eax
		ret
	:

	invoke GetProcAddress,[hLib],"VirtualFreeEx"
	mov [pVirtualFreeEx],eax

	xor eax,eax
	RET
ENDF

GetItemPos FRAME hlv,iItem,pPoint
	fs mov eax,[18h]
	cmp eax,7FFDE000h ; Test for NT
	je >
		invoke GetItemPos9x,[hlv],[iItem],[pPoint]
		RET
	:
		invoke GetItemPosNT,[hlv],[iItem],[pPoint]
		RET
ENDF

GetRemoteItem FRAME hlv,pLVItem
	fs mov eax,[18h]
	cmp eax,7FFDE000h ; Test for NT
	je >
		invoke GetRemoteItem9x,[hlv],[pLVItem]
		RET
	:
		invoke GetRemoteItemNT,[hlv],[pLVItem]
		RET
ENDF

GetItemPos9x FRAME hlv,iItem,pPoint
	LOCAL pMem		:D

	; allocate memory on the shared heap
	invoke Alloc,8
	mov [pMem],eax

	; Get the item position and place it in the shared buffer
	invoke SendMessageA,[hlv],LVM_GETITEMPOSITION,[iItem],[pMem]

	; Copy the shared buffer to the local structure
	mov edx,[pPoint]
	mov eax,[pMem]
	mov eax,[eax]
	mov [edx],eax
	mov eax,[pMem]
	mov eax,[eax+4]
	mov [edx+4],eax

	invoke Free,[pMem]

	RET
ENDF

GetRemoteItem9x FRAME hlv,pLVItem
	uses ebx,edi,esi
	LOCAL pMem		:D

	mov edi,[pLVItem]
	; Calculate the size of buffer needed
	mov ecx,SIZEOF LV_ITEM
	add ecx,[edi+LV_ITEM.cchTextMax]
	inc ecx

	; Allocate memory on the shared heap
	invoke Alloc,ecx
	mov [pMem],eax

	; Substitute the address of the local pszText buffer for the shared one
	mov esi,eax
	add esi,SIZEOF LV_ITEM

	mov ebx,[edi+LV_ITEM.pszText]
	mov [edi+LV_ITEM.pszText],esi

	; Write the LV_ITEM structure to the shared buffer
	invoke MemCopy,[pLVItem],[pMem],SIZEOF LV_ITEM

	; Get the item info, using the shared buffer
	invoke SendMessageA,[hlv],LVM_GETITEM,0,[pMem]

	; Copy the shared LV_ITEM into our local LV_ITEM
	invoke MemCopy,[pMem],[pLVItem],SIZEOF LV_ITEM

	; Reset the address of the pszText buffer
	mov [edi+LV_ITEM.pszText],ebx

	; Copy the text from the shared buffer
	invoke MemCopy,esi,ebx,[edi+LV_ITEM.cchTextMax]

	invoke Free,[pMem]

	RET
ENDF

MemCopy FRAME lpSource,lpDest,nBytes
	uses edi,esi,ecx
	cld
	mov edi,[lpDest]
	mov esi,[lpSource]
	mov ecx,[nBytes]

	; do the evenly divisible ones
	shr ecx,2
	rep movsd

	; do the remainder
	mov ecx,[nBytes]
	and ecx,3
	rep movsb

	RET
ENDF

GetItemPosNT FRAME hlv,iItem,pPoint
	LOCAL pMem		:D
	LOCAL PID		:D
	LOCAL hProcess	:D
	LOCAL cbWritten	:D

	; Get the ID of the process that created the desktop listview
	invoke GetWindowThreadProcessId,[hlv],OFFSET PID

	; Open the process with Virtual memory priviledges
	invoke OpenProcess,PROCESS_VM_OPERATION \
		+ PROCESS_VM_READ + PROCESS_VM_WRITE,0,[PID]
	mov [hProcess],eax

	; Create a buffer inside the process space of the desktop listview
	invoke VirtualAllocEx,eax,0,8,MEM_COMMIT,PAGE_READWRITE
	mov [pMem],eax

	; Get the item position and place it in the remote buffer
	invoke SendMessageA,[hlv],LVM_GETITEMPOSITION,[iItem],[pMem]

	; Copy the remote buffer to the local structure
	invoke ReadProcessMemory,[hProcess],[pMem],[pPoint],\
		8,OFFSET cbWritten

	; Clean up and leave
	invoke VirtualFreeEx,[hProcess],[pMem],0,MEM_RELEASE
	invoke CloseHandle,[hProcess]

	RET
ENDF

GetRemoteItemNT FRAME hlv,pLVItem
	uses ebx,edi,esi
	LOCAL pMem		:D
	LOCAL PID		:D
	LOCAL hProcess	:D
	LOCAL cbWritten	:D

	; Get the ID of the process that created the desktop listview
	invoke GetWindowThreadProcessId,[hlv],OFFSET PID

	; Open the process with Virtual memory priviledges
	invoke OpenProcess,PROCESS_VM_OPERATION \
		+ PROCESS_VM_READ + PROCESS_VM_WRITE,0,[PID]
	mov [hProcess],eax

	mov edi,[pLVItem]

	; Calculate the size of buffer needed
	mov ecx,SIZEOF LV_ITEM
	add ecx,[edi+LV_ITEM.cchTextMax]
	inc ecx

	; Create a buffer inside the process space of the desktop listview
	invoke VirtualAllocEx,eax,0,ecx,MEM_COMMIT,PAGE_READWRITE
	mov [pMem],eax

	; Substitute the address of the local pszText buffer for the remote one
	mov esi,eax
	add esi,SIZEOF LV_ITEM

	mov ebx,[edi+LV_ITEM.pszText]
	mov [edi+LV_ITEM.pszText],esi

	; Write the LV_ITEM structure to the remote process buffer
	invoke WriteProcessMemory,[hProcess],[pMem],\
		[pLVItem],SIZEOF LV_ITEM,OFFSET cbWritten

	; Get the item info, using the remote buffer
	invoke SendMessageA,[hlv],LVM_GETITEM,0,[pMem]

	; Copy the remote LV_ITEM into our local LV_ITEM 
	invoke ReadProcessMemory,[hProcess],[pMem],\
		[pLVItem],SIZEOF LV_ITEM,OFFSET cbWritten

	; Reset the address of the pszText buffer
	mov [edi+LV_ITEM.pszText],ebx

	; Copy the text from the remote buffer
	invoke ReadProcessMemory,[hProcess],esi,ebx,\
		[edi+LV_ITEM.cchTextMax],OFFSET cbWritten

	; Free the memory and close the remote process
	invoke VirtualFreeEx,[hProcess],[pMem],0,MEM_RELEASE
	invoke CloseHandle,[hProcess]

	RET
ENDF

FindFullName FRAME hlv,pidl,pOutPath,pType
	LOCAL IDL[256]	:D
	LOCAL PID		:D
	LOCAL hProcess	:D
	LOCAL cbWritten	:D
	LOCAL sfi		:SHFILEINFO

	; Get the ID of the process that created the desktop listview
	invoke GetWindowThreadProcessId,[hlv],OFFSET PID
	; Open the process with Virtual read priviledges
	invoke OpenProcess,PROCESS_VM_READ,0,[PID]
	mov [hProcess],eax
	; Copy the remote IDL into our local IDL 
	invoke ReadProcessMemory,[hProcess],[pidl],\
		offset IDL,1024,OFFSET cbWritten
	invoke CloseHandle,[hProcess]

	invoke SHGetFileInfoA,offset IDL,0,offset sfi, \
		SIZEOF SHFILEINFO,SHGFI_SYSICONINDEX+SHGFI_TYPENAME+SHGFI_PIDL
	invoke lstrcpyA,[pType],offset sfi.szTypeName

	invoke SHGetPathFromIDListA,offset IDL,[pOutPath]
	mov eax,[sfi.iIcon]
	RET
ENDF
